package com.key.vibekeyboard.Adapter;

import android.content.Intent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.bumptech.glide.Glide;
import com.bumptech.glide.load.resource.bitmap.CenterCrop;
import com.bumptech.glide.load.resource.bitmap.RoundedCorners;
import com.bumptech.glide.request.RequestOptions;
import com.key.vibekeyboard.Activity.DownloadActivity;
import com.key.vibekeyboard.R;
import com.key.vibekeyboard.Room.WallpaperInfo;

import java.util.ArrayList;
import java.util.List;

public class DownlaodRecyclerViewAdapter extends RecyclerView.Adapter<DownlaodRecyclerViewAdapter.DownlaodRecyclerViewHolder> {

    private DownloadActivity downloadActivity;
    private WallpaperInfo wallpaperInfo;
    private List<WallpaperInfo> list;

    public DownlaodRecyclerViewAdapter(DownloadActivity downloadActivity, WallpaperInfo wallpaperInfo, List<WallpaperInfo> list) {
        this.downloadActivity = downloadActivity;
        this.wallpaperInfo = wallpaperInfo;
        this.list = list;
    }

    @NonNull
    @Override
    public DownlaodRecyclerViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.home_recycler_item, parent, false);
        return new DownlaodRecyclerViewHolder(view);
    }

    @Override
    public void onBindViewHolder(@NonNull DownlaodRecyclerViewHolder holder, int position) {

        WallpaperInfo wallpaperInfo1 = list.get(position);

        List<WallpaperInfo> limitedList = list.subList(0, Math.min(20, list.size()));

        holder.imageView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(downloadActivity, DownloadActivity.class);
                intent.putExtra("wallpaperInfo", wallpaperInfo1); // wallpaperInfo 已经实现了 Parcelable
                intent.putParcelableArrayListExtra("list", new ArrayList<>(limitedList)); // list 中的 WallpaperInfo 对象实现了 Parcelable
                downloadActivity.startActivity(intent);
            }
        });

        // 应用圆角变换
        RequestOptions options = new RequestOptions()
                .placeholder(R.mipmap.splash)
                .error(R.mipmap.splash)
                .transform(new CenterCrop())
                .transform(new RoundedCorners(16)); // 设置圆角度数

        Glide.with(downloadActivity)
                .load(list.get(position).getPreview())
                .apply(options)
                .into(holder.imageView);

    }

    @Override
    public int getItemCount() {
        return list.size();
    }

    public static class DownlaodRecyclerViewHolder extends RecyclerView.ViewHolder {

        private ImageView imageView;

        public DownlaodRecyclerViewHolder(@NonNull View itemView) {
            super(itemView);
            imageView = itemView.findViewById(R.id.home_recycler_image);
        }
    }

}
